/* NAME: Kirill Vasil'evich Timofeev, 322
 * ASGN: N1
 */
#include <QtGui>

#include "Controller.h"
#include "mainwindow.h"
#include "Logic.h"
#include "liblinear-1.8\linear.h"

Controller::Controller()
{
    createActions();
}

Controller::~Controller()
{
    deleteActions();
}

void Controller::training()
{
    msg1 = "Input the directory with training Images";
    msg2 = "Input the file with locations";
    msg3 = "Output the file with model";
    files(true ,true ,true, false);
    logic.getFilesTr();
    mainWin.labelIm->setPixmap(*logic.image);
    mainWin.statusBar()->showMessage("Training Completed", 2000);
    mainWin.menu2();
}

void Controller::usingModel()
{
    msg3 = "Input the file with model";
    files(false ,false ,true ,false);
    mainWin.menu2();
}

void Controller::search(bool InImage)
{
    if (InImage)
    {
        msg2 = "Input the Image";
        msg4 = "Output the file with locations";
        files(false ,true ,false ,true);
    }
    else
    {
        msg1 = "Input the directory with testing Images";
        msg2 = "Input the file with names of images";
        msg4 = "Output the file with locations";
        files(true ,true, false, true);
    }

    logic.outFile = new QFile(logic.curOutFile);
    logic.outFile->open(QIODevice::ReadWrite | QIODevice::Truncate);
    logic.outFile->close();
    // NOW LOAD MODEL AND CLASSIFY
    if((logic.myModel=load_model(qPrintable(logic.curModelFile)))!=0)
    {
        if (InImage) logic.getFilesSImg();
        else logic.getFilesSDir();
        mainWin.labelIm->setPixmap(*logic.image);
        mainWin.repaint();
        if (InImage) mainWin.statusBar()->showMessage("Searching in the Image Completed", 2000);
        else mainWin.statusBar()->showMessage("Searching in the directory Completed", 2000);
    }
    else mainWin.statusBar()->showMessage("can't load model from file", 2000);
    free_and_destroy_model(&logic.myModel);
}

void Controller::serIn()
{
    search(true);
}

void Controller::serDir()
{
    search(false);
}

void Controller::PRcount()
{
    msg2 = "Input the file with found locations";
    msg3 = "Input the file with right locations";
    files(false, true, true, false);
    char *temp = logic.PRcount();
    mainWin.mesBox(temp);
    mainWin.statusBar()->showMessage(temp, 2000);
}

void Controller::files(bool a , bool b , bool c , bool d)
{
    if (a) logic.curCat = mainWin.message(msg1, false);
    if (b) logic.curInFile = mainWin.message(msg2, true);
    if (c) logic.curModelFile = mainWin.message(msg3, true);
    if (d) logic.curOutFile = mainWin.message(msg4, true);

}

void Controller::exit()
{
    mainWin.exit();
    close();
}

void Controller::createActions()
{
    useAct = new QAction(tr("&Use the Model..."), this);
    useAct->setStatusTip(tr("Use the Model"));
    connect(mainWin.button0, SIGNAL(pressed()), this, SLOT(usingModel()));

    PRAct = new QAction(tr("&Count Precision and Recall..."), this);
    PRAct->setStatusTip(tr("Count Precision and Recall"));
    connect(mainWin.button6, SIGNAL(pressed()), this, SLOT(PRcount()));

    trainAct = new QAction(tr("&train..."), this);
    trainAct->setStatusTip(tr("train"));
    connect(mainWin.button1, SIGNAL(pressed()), this, SLOT(training()));

    retrainAct = new QAction(tr("&retrain..."), this);
    retrainAct->setStatusTip(tr("retrain"));
    connect(mainWin.button5, SIGNAL(pressed()), this, SLOT(training()));

    serDirAct = new QAction(tr("&tra..."), this);
    serDirAct->setStatusTip(tr("tra"));
    connect(mainWin.button2, SIGNAL(pressed()), this, SLOT(serDir()));

    serImAct = new QAction(tr("&tr..."), this);
    serImAct->setStatusTip(tr("tr"));
    connect(mainWin.button3, SIGNAL(pressed()), this, SLOT(serIn()));

    exitAct = new QAction(tr("&in..."), this);
    exitAct->setStatusTip(tr("in"));
    connect(mainWin.button4, SIGNAL(pressed()), this, SLOT(exit()));


}

void Controller::deleteActions()
{
    delete useAct;
    delete PRAct;
    delete trainAct;
    delete retrainAct;
    delete serDirAct;
    delete serImAct;
    delete exitAct;


}
